/**
  ******************************************************************************
  * @file    vk1056.c
  * @author  kevin_guo
  * @version V1.2
  * @date    05-17-2020
  * @brief   This file contains all the vk1056 functions. 
	*          ļ VK1056
  ******************************************************************************
  * @attention
  ******************************************************************************
  */	
/* Includes ------------------------------------------------------------------*/
#include "vk1056.h"
  
/* extern variables ----------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define VK1056_CLK 10 //WRźƵ,delay_nusʵ 50->10kHz 10->50kHz 5->100kHz
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
//segtab[]ӦʵʵоƬLCDߣ߼-VK1056ο·
unsigned char vk1056_segtab[VK1056_SEGNUM]={
	9,10,11,12,13,14,15,16,17,18,19,20,21,22					//SEG9-SEG22
};
//LCDʵֻSEG11SEG22,ʹ
//.hļVK1056_SEGNUM=12
//const unsigned char vk1056_segtab[VK1056_SEGNUM]={
//	11,12,13,14,15,16,17,18,19,20,21,22					//SEG11-SEG22
//};
//vk1056_dispramӦоƬʾRAM
unsigned char vk1056_dispram[VK1056_SEGNUM];
//Ӧvk1056_segtab[VK1056_SEGNUM]
//ʾRAM bufferֻʹõ4λbit0->com0,bit1->com1,bit2->com2,bit3->com3
//LCD ʵ  38
//1ǰλ2ʮλ3Ǹλ
/*ʾbufferlcdͼӳϵ
vk1056_dispram[VK1056_SEGNUM]=
{//com3   com2   com1     com0 //ӦоƬSEG  ӦʾRAM
	1D,     1E,    1F,      1A,     //seg10   		vk1056_dispram[1]
	  ,     1C,    1G,      1B,     //seg11				vk1056_dispram[2]
	2D,     2E,    2F,      2A,     //seg12				vk1056_dispram[3]	
	  ,     2C,    2G,      2B,     //seg13				vk1056_dispram[4]
	3D,     3E,    3F,      3A,		  //seg14				vk1056_dispram[5]
	  ,     3C,    3G,      3B,			//seg15				vk1056_dispram[6]
}
*/
/*8ֵ 
     A
   F   B
     G
	 E   C
	   D
*/
unsigned char shuzi_zimo[15]= //ַֺģ
{
//0    1    2    3    4    5    6    7    8    9    -    L    o    H    i 
	0xF5,0x05,0xD3,0x97,0x27,0xB6,0xF6,0x15,0xF7,0xB7,0x02,0xE0,0xC6,0x67,0x05
};
unsigned char vk1056_addrbit=6;//icramַA5-A0,
unsigned char vk1056_segi,vk1056_comi;
unsigned char vk1056_maxcom;//com4com3com2com
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/
/*******************************************************************************
* Function Name  : delay_nus
* Description    : ʱ1uS
* Input          : n->ʱʱnuS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}
/*******************************************************************************
* Function Name  : delay_nms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nms(unsigned long int n)
{
	while(n--)
	{
		delay_nus(1000);
	}
}
/*******************************************************************************
* Function Name  : WriteClock
* Description    : WRʱ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void WriteClockVk1056(void)
{
	VK1056_WR_L(); 
	delay_nus(VK1056_CLK);
	VK1056_WR_H();	
	delay_nus(VK1056_CLK);	
}
/*******************************************************************************
* Function Name  : WriteCommand
* Description    : д
* Input          : FunctonCode->/ 
* Output         : None
* Return         : None
*******************************************************************************/
void WriteCommandVk1056(unsigned char FunctonCode)
{
	unsigned char Shift = 0x80; 
	unsigned char i;
	
	VK1056_CS_L();   //CS Ƭѡ   
	delay_nus(VK1056_CLK/2);
	VK1056_DATA_H();  
	WriteClockVk1056();
	VK1056_DATA_L();  
	WriteClockVk1056();
	VK1056_DATA_L();  
	WriteClockVk1056();

	for(i = 0; i < 8; i++) 
	{
	 if(Shift & FunctonCode) 	
		 VK1056_DATA_H(); 
	 else 
		 VK1056_DATA_L();	  

	 WriteClockVk1056();
	 Shift = Shift >> 1;
	}
  VK1056_DATA_L(); 
	WriteClockVk1056();	//һ0һλ X
  VK1056_CS_H(); 			//CS Ƭѡ  
	delay_nus(VK1056_CLK/2);
  VK1056_DATA_H(); 
}

/*******************************************************************************
* Function Name  : Write1Data
* Description    : д1SEGݵʾRAMbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* Input          : Addr->дramĵַ  
* 							 : Databuf->дram(1ֽݵ4λЧ)  
* Output         : None
* Return         : None
*******************************************************************************/
void Write1DataVk1056(unsigned char Addr,unsigned char Dat)
{
	unsigned char i; 
	unsigned char Shift;
	
	Shift = 0x20; //θ3λ ֻ5λ
	
	VK1056_CS_L();  //CS Ƭѡ
	delay_nus(VK1056_CLK/2);

	VK1056_DATA_H();  
	WriteClockVk1056();  //101
	VK1056_DATA_L();  
	WriteClockVk1056();
	VK1056_DATA_H();  
	WriteClockVk1056();

	for( i = 0; i < vk1056_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VK1056_DATA_H(); 		
		else  
			VK1056_DATA_L();
		WriteClockVk1056();		
		Shift = Shift >> 1; 
	}
  Shift = 0x01;
  for (i = 0; i < 4; i++) 
	{

		if( Dat & Shift) 
			VK1056_DATA_H();		 
   	else  
			VK1056_DATA_L();
		WriteClockVk1056();
		Shift = Shift << 1;
	}   
  VK1056_CS_H(); //CS Ƭѡ
	delay_nus(VK1056_CLK/2);	
  VK1056_DATA_H(); 
}
/*******************************************************************************
* Function Name  : WritenData
* Description    : дnSEGݵʾRAMbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* Input          : Addr->дramʼַ  
* 							 : Databuf->дramָ(ÿֽݵ4λЧ)  
* 							 : Cnt->дramݸ
* Output         : None
* Return         : None
*******************************************************************************/
void WritenDataVk1056(unsigned char Addr,unsigned char *Databuf,unsigned char Cnt)
{
	unsigned char i,j; 
	unsigned char Shift;
	unsigned char dataval; 
	
	VK1056_CS_L();   //CS Ƭѡ 
	delay_nus(VK1056_CLK/2);

	VK1056_DATA_H();  
	WriteClockVk1056();  //101
	VK1056_DATA_L();  
	WriteClockVk1056();
	VK1056_DATA_H();  
	WriteClockVk1056();

	Shift = 0x20;
	for( i = 0; i < vk1056_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VK1056_DATA_H(); 		
		else  
			VK1056_DATA_L();
		WriteClockVk1056();		
		Shift = Shift >> 1; 
	}
	for (j = 0; j < Cnt; j++) 
	{
		Shift = 0x01;
		dataval=*Databuf++;
		for (i = 0; i < 4; i++) 
		{
			if( dataval & Shift) 
				VK1056_DATA_H();		 
			else  
				VK1056_DATA_L();
			WriteClockVk1056();
			Shift = Shift << 1;
		}   
	}
  VK1056_CS_H();   //CS Ƭѡ
	delay_nus(VK1056_CLK/2);	 
  VK1056_DATA_H(); 
}
/*******************************************************************************
* Function Name  : Vk1056_DisAll
* Description    : SEGʾͬһݣbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* 					     : 磺0x0fȫ 0x00ȫ 0x05 0x0a 0x03 
* Input          dat->дram(1ֽݵ4λЧ)  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1056_DisAll(unsigned char dat)
{
	unsigned char segi;
	unsigned char dispram[32];
	
	for(segi=0;segi<32;segi++)
	{
		dispram[segi]=0x00;
	}
	for(segi=9;segi<23;segi++)
	{
		dispram[segi]=dat;
	}
	WritenDataVk1056(0,dispram,32);//4bitַԶ1
}
/*******************************************************************************
* Function Name  : DisSegComOn
* Description    : 1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1056_DisSegComOn(unsigned char seg,unsigned char com)
{
		Write1DataVk1056(seg,(1<<com));
}
/*******************************************************************************
* Function Name  : DisSegComOff
* Description    : ر1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1056_DisSegComOff(unsigned char seg,unsigned char com)
{
		Write1DataVk1056(seg,~(1<<com));
}
/*******************************************************************************
* Function Name  : Enter_Standby
* Description    : ͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1056_Enter_Standby(void)
{	
	//ʹLCDOFFSYSDIS,ϵͳڵ͹״̬
	//ֻʹƬRCʱԴʱ,ʹϵͳ͹״̬
	WriteCommandVk1056(OSC_OFF);
	WriteCommandVk1056(DISP_OFF);
}
/*******************************************************************************
* Function Name  : Exit_Standby
* Description    : ˳͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1056_Exit_Standby(void)
{	
	//˳͹״̬vk1056
	WriteCommandVk1056(OSC_ON);
	WriteCommandVk1056(DISP_ON);
	WriteCommandVk1056(COM_1_3__4);vk1056_maxcom=4;	//1/3bias 4com
//	WriteCommandVk1056(COM_1_3__3);vk1056_maxcom=3;	//1/3bias 3com
//	WriteCommandVk1056(COM_1_3__2);vk1056_maxcom=2;	//1/3bias 2com
//	WriteCommandVk1056(COM_1_2__4);vk1056_maxcom=4;	//1/2bias 4com
//	WriteCommandVk1056(COM_1_2__3);vk1056_maxcom=3;	//1/2bias 3com
//	WriteCommandVk1056(COM_1_2__2);vk1056_maxcom=2;	//1/2bias 2com
}
/*******************************************************************************
* Function Name  : Lowlevel_Init
* Description    : ͨGPIO
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1056_Lowlevel_Init(void)
{
	//ͨߵƽͬӵƽת·
	//˺ݿͻƬӦ޸	
	GPIO_SetMode(VK1056_CS_PORT, VK1056_CS_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1056_WR_PORT, VK1056_WR_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1056_DAT_PORT, VK1056_DAT_PIN, GPIO_MODE_OUTPUT);	//ֻʾݿΪIO
		
	VK1056_CS_H();                 
	VK1056_WR_H();  
	VK1056_DATA_H(); 	
}
/*******************************************************************************
* Function Name  : Init
* Description    : ʼ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1056_Init(void)
{	
	//ܽøݿͻƬӦ޸
	Vk1056_Lowlevel_Init();
	//
	WriteCommandVk1056(OSC_ON);
	WriteCommandVk1056(DISP_ON);
	WriteCommandVk1056(COM_1_3__4);vk1056_maxcom=4;	//1/3bias 4com
//	WriteCommandVk1056(COM_1_3__3);vk1056_maxcom=3;	//1/3bias 3com com2/com1/com0
//	WriteCommandVk1056(COM_1_3__2);vk1056_maxcom=2;	//1/3bias 2com com1/com0
//	WriteCommandVk1056(COM_1_2__4);vk1056_maxcom=4;	//1/2bias 4com
//	WriteCommandVk1056(COM_1_2__3);vk1056_maxcom=3;	//1/2bias 3com com2/com1/com0
//	WriteCommandVk1056(COM_1_2__2);vk1056_maxcom=2;	//1/2bias 2com com1/com0
	//ϵĬ(δùܹرս͹)
//	WriteCommandVk1056(BUZZ_2KHZ);
//	WriteCommandVk1056(BUZZ_4KHZ);
//	WriteCommandVk1056(BUZZ_ON);
	WriteCommandVk1056(BUZZ_OFF);
	WriteCommandVk1056(IRQ_DIS);
	WriteCommandVk1056(TIMER_DIS);
	WriteCommandVk1056(WDT_DIS);
}
/*******************************************************************************
* Function Name  : disp_3num
* Description    : ʾ3λ
* Input          dat->3λ ʮ 
* Output         : None
* Return         : None
*******************************************************************************/
void disp_3num(unsigned int dat)
{		
	unsigned dat8;
	
	dat8=dat/100%10;	//ʾλ
	vk1056_dispram[1]=shuzi_zimo[dat8]>>4;
	vk1056_dispram[2]&=0xf8;
	vk1056_dispram[2]|=shuzi_zimo[dat8]&0x07;
	
	dat8=dat/10%10; 	//ʾʮλ
	vk1056_dispram[3]=shuzi_zimo[dat8]>>4;
	vk1056_dispram[4]&=0xf8;
	vk1056_dispram[4]|=shuzi_zimo[dat8]&0x07;
	
	dat8=dat%10;			//ʾλ
	vk1056_dispram[5]=shuzi_zimo[dat8]>>4;
	vk1056_dispram[6]&=0xf8;
	vk1056_dispram[6]|=shuzi_zimo[dat8]&0x07;
		
	if(dat<100)				//С100λʾ
	{
		vk1056_dispram[1]&=0xf0;
		vk1056_dispram[2]&=0xf8;
	}
	if(dat<10) 	//С10ʮλʾ
	{
		vk1056_dispram[3]&=0xf0;
		vk1056_dispram[4]&=0xf8;
	}
	//SEG11
//	Write1DataVk1056(10,vk1056_dispram[1]);
//	Write1DataVk1056(11,vk1056_dispram[2]);
//	Write1DataVk1056(12,vk1056_dispram[3]);
//	Write1DataVk1056(13,vk1056_dispram[4]);
//	Write1DataVk1056(14,vk1056_dispram[5]);
//	Write1DataVk1056(15,vk1056_dispram[6]);
	//SEGͶ
	WritenDataVk1056(10,&vk1056_dispram[1],6);
}	
/*******************************************************************************
* Function Name  : test_Main
* Description    : 
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1056_Main(void)
{	
	Vk1056_Init();
	Vk1056_DisAll(0x00);
	while(1)
	{
		Vk1056_DisAll(0x0f);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vk1056_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		disp_3num(123);           //ʾ123
		delay_nms(3000);					//ʱ3S
		
		Vk1056_DisAll(0x00);			//LCDȫ
		for(vk1056_segi=0;vk1056_segi<VK1056_SEGNUM;vk1056_segi++)//seg
		{
			for(vk1056_comi=0;vk1056_comi<vk1056_maxcom;vk1056_comi++)//com
			{
				Vk1056_DisSegComOn(vk1056_segtab[vk1056_segi],vk1056_comi);	//LCD
				delay_nms(300);				//ʱ300mS
				Vk1056_DisAll(0x00);	//LCDȫ
			}
		}
		
		Vk1056_DisAll(0x0f);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		for(vk1056_segi=0;vk1056_segi<VK1056_SEGNUM;vk1056_segi++)//seg
		{
			for(vk1056_comi=0;vk1056_comi<vk1056_maxcom;vk1056_comi++)//com
			{
				Vk1056_DisSegComOff(vk1056_segtab[vk1056_segi],vk1056_comi);	//LCDر
				delay_nms(300);				//ʱ300mS
				Vk1056_DisAll(0x0f);	//LCDȫ
			}
		}
		delay_nms(1000);					//ʱ1S
		
		Vk1056_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vk1056_Enter_Standby();		//͹ģʽ
		delay_nms(5000);					//ʱ5S
		
		Vk1056_Exit_Standby();		//˳͹ģʽ
	}
}
/************************END OF FILE****/
